if RequiredScript == "lib/managers/menumanager" then
	local mmanager_do_clear_progress = MenuManager.do_clear_progress
	
	function MenuManager:do_clear_progress()
		managers.achievment:clear_all_steam()
		managers.statistics:reset()
		mmanager_do_clear_progress(self)
	end

	if Global.you_died then
		Global.you_died = false	
		DelayedCalls:Add('RRoulette_RunNow', 1, function()
			MenuManager:do_clear_progress()			

			-- Code from Dr Newbie's One Life mod
			local bm = managers.blackmarket
			for _, category in pairs({"primaries","secondaries","masks"}) do
				for k, v in pairs(bm._global.crafted_items[category]) do
					if category == "masks" then 
						local mask = bm:get_crafted_category_slot("masks", k)
						local mask_id = mask.mask_id
						if (k ~= bm:equipped_mask_slot()) and (mask_id ~= "character_locked") then
							bm:on_sell_mask(k, true)
						end
					else
						local weapon = bm:get_crafted_category_slot(category, k)
						if weapon then
							if bm:equipped_weapon_slot(category) ~= k then 
								bm:on_sell_weapon(category, k, true)
							end
						end
					end
				end
			end
			
			managers.skilltree:infamy_reset()			

			QuickMenu:new(
				"You Died",
				"I think you got shot or something? Anyways, good luck out there champ!",
				{{text = "ok", is_cancel_button = true}},
				true
			)
		end)
	end
	
elseif RequiredScript == "lib/states/missionendstate" then
	local mes_at_enter = MissionEndState.at_enter

	function MissionEndState:at_enter(old_state, params)
		local russian_roulette = math.random(1,6) -- Change 6 to any value you want, it's the max random number you get. It'll give you 1 chances out of the amount you put to reset.
		
		if russian_roulette == 6 then
			Global.you_died = true
			
			DelayedCalls:Add('RussianRoulette_RunSet', 1, function()
				if Global.game_settings.single_player then
					MenuCallbackHandler:_dialog_end_game_yes()
				else
					setup:load_start_menu()
				end
			end)
		else
			mes_at_enter(self, old_state, params)
		end
	end
end